<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__smif" kind="group">
    <compoundname>group_smif</compoundname>
    <title>SMIF         (Serial Memory Interface)</title>
    <innergroup refid="group__group__smif__macros">Macros</innergroup>
    <innergroup refid="group__group__smif__functions">Functions</innergroup>
    <innergroup refid="group__group__smif__data__structures">Data Structures</innergroup>
    <innergroup refid="group__group__smif__enums">Enumerated Types</innergroup>
    <briefdescription>
<para>The SPI-based communication interface to the external quad SPI (QSPI) high-speed memory devices. </para>    </briefdescription>
    <detaileddescription>
<para>The functions and other declarations used in this driver are in cy_smif.h and cy_smif_memslot.h (if used). If you are using the ModusToolbox QSPI Configurator, also include cycfg_qspi_memslot.h.</para><para><bold>SMIF: Serial Memory Interface</bold>: This IP block implements an SPI-based communication interface for interfacing external memory devices to PSoC. The SMIF supports SPI, dual SPI (DSPI), quad SPI (QSPI), dual QSPI and octal SPI.</para><para>Features<itemizedlist>
<listitem><para>Standard SPI Master interface</para></listitem><listitem><para>Supports single/dual/quad/octal SPI memory devices</para></listitem><listitem><para>Supports dual quad SPI mode</para></listitem><listitem><para>Design-time configurable support for multiple (up to 4) external serial memory devices</para></listitem><listitem><para>eXecute-In-Place (XIP) operation mode for both read and write accesses with 4KB XIP read cache and on-the-fly encryption and decryption</para></listitem><listitem><para>Supports external serial memory initialization via <ulink url="https://www.jedec.org/standards-documents/docs/jesd216b">Serial Flash Discoverable Parameters (SFDP)</ulink> standard</para></listitem></itemizedlist>
</para><para>The primary usage model for the SMIF is that of an external memory interface. The SMIF is capable of interfacing with different types of memory, up to four types.</para><para><bold>SMIF</bold> driver is divided into three layers<itemizedlist>
<listitem><para>cy_smif.h API</para></listitem><listitem><para>cy_smif_memslot.h API</para></listitem><listitem><para>SMIF configuration structures</para></listitem></itemizedlist>
</para><para>The SMIF API is divided into the low-level functions and memory-slot functions. Use the low level API for the SMIF block initialization and for implementing a generic SPI communication interface using the SMIF block.</para><para>The memory slot API has functions to implement the basic memory operations such as program, read, erase etc. These functions are implemented using the memory parameters in the memory device configuration data structure. The <ref kindref="member" refid="group__group__smif__mem__slot__functions_1ga6f38cc37ab0e6fcb97d2675d1ae11771">Cy_SMIF_MemInit()</ref> API initializes all the memory slots based on the settings in the array.</para><para><image name="smif_1_0_p01_layers.png" type="html" />
</para><para>SMIF Configuration Tool is a stand-alone application, which is a part of PDL (Creator) and could be found in &lt;PDL_DIR&gt;/tools/&lt;OS_DIR&gt;/SMIFConfigurationTool (e.g. for PDL 3.0.0 and Windows OS PDL/3.0.0/tools/win/SMIFConfigurationTool).</para><para>In ModusToolbox this tool is called QSPI Configurator. QSPI Configurator is a part of PSoC 6 Software Library and can be found in &lt;ModusToolbox&gt;/tools/qspi-configurator-1.1</para><para>Tool generates *.c and *.h file with configuration structures. These configuration structures are input parameters for cy_smif_memslot API level</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition warning"&gt;&lt;p class="admonition-title"&gt;warning&lt;/p&gt;&lt;p&gt;&lt;p&gt;The driver is not responsible for external memory persistence. You cannot edit a buffer during the Read/Write operations. If there is a memory error, the SMIF ip block can require a reset. To determine if this has happened, check the SMIF busy status using &lt;a href="group__group__smif__low__level__functions.html#group__group__smif__low__level__functions_1ga58e965697047847ce906329eb6b5341c"&gt;Cy_SMIF_BusyCheck()&lt;/a&gt; and implement a timeout. Reset the SMIF block by toggling CTL.ENABLED. Then reconfigure the SMIF block.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;For the Write operation, check that the SMIF driver has completed transferring by calling </verbatim><ref kindref="member" refid="group__group__smif__low__level__functions_1ga58e965697047847ce906329eb6b5341c">Cy_SMIF_BusyCheck()</ref>. Also, check that the memory is available with <ref kindref="member" refid="group__group__smif__mem__slot__functions_1gae648d554521de4d840ace68af2db65a3">Cy_SMIF_MemIsBusy()</ref> before proceeding.</para><para>Simple example of external flash memory programming using low level SMIF API. All steps mentioned in example below are incorporated in <ref kindref="member" refid="group__group__smif__mem__slot__functions_1gac93c10b75a6f4f69da062ee27515e3b5">Cy_SMIF_MemCmdWriteEnable()</ref>, <ref kindref="member" refid="group__group__smif__mem__slot__functions_1ga81dda3370adfb1c5ae37c4ff8657d527">Cy_SMIF_MemCmdProgram()</ref>, and <ref kindref="member" refid="group__group__smif__mem__slot__functions_1gae648d554521de4d840ace68af2db65a3">Cy_SMIF_MemIsBusy()</ref> of the <ref kindref="compound" refid="group__group__smif__mem__slot__functions">memory slot level API</ref>. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition warning"&gt;&lt;p class="admonition-title"&gt;warning&lt;/p&gt;&lt;p&gt;&lt;p&gt;Example is simplified, without checks of error conditions. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Flash memories need erase operation before programming. Refer to external memory datasheet for specific memory commands.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />write<sp />operation<sp />in<sp />external<sp />memory.<sp />Send<sp />Write<sp />Enable<sp />command<sp />to</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />external<sp />memory.<sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__low__level__functions_1ga5abea630fca93c72faece8b23549cd11">Cy_SMIF_TransmitCommand</ref>(<sp />SMIF,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />0x06U,<sp /></highlight><highlight class="comment">/*<sp />External<sp />memory<sp />write<sp />enable<sp />command<sp />*/</highlight><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__enums_1ggab71e4b1f4c80b3e8c82dd85570415e44ac1096798c3195819d57ad16de46b4ed7">CY_SMIF_WIDTH_SINGLE</ref>,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CMD_WITHOUT_PARAM,<sp /></highlight><highlight class="comment">/*<sp />Command<sp />does<sp />not<sp />have<sp />parameters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CMD_WITHOUT_PARAM,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__enums_1ggab71e4b1f4c80b3e8c82dd85570415e44ac1096798c3195819d57ad16de46b4ed7">CY_SMIF_WIDTH_SINGLE</ref>,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__enums_1ggad776a0db9224477ab865254a32d9e312ae942102fb4b1a03a13ca8950b607520d">CY_SMIF_SLAVE_SELECT_0</ref>,<sp /></highlight><highlight class="comment">/*<sp />External<sp />memory<sp />connected<sp />to<sp />nSS0<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />1U,<sp /></highlight><highlight class="comment">/*<sp />Disable<sp />nSS<sp />after<sp />command<sp />transfered<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;smifContext);<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wait<sp />while<sp />SMIF<sp />IP<sp />is<sp />transferring<sp />command<sp />to<sp />external<sp />memory<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__smif__low__level__functions_1ga58e965697047847ce906329eb6b5341c">Cy_SMIF_BusyCheck</ref>(SMIF));</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />tst_txBuffer[TX_SIZE];<sp /></highlight><highlight class="comment">/*<sp />Buffer<sp />to<sp />put<sp />read<sp />date<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Send<sp />page<sp />program<sp />command<sp />to<sp />external<sp />memory<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__low__level__functions_1ga5abea630fca93c72faece8b23549cd11">Cy_SMIF_TransmitCommand</ref>(<sp />SMIF,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />0x02U,<sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Page<sp />Program<sp />external<sp />memory<sp />command<sp />*/</highlight><highlight class="normal"><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__enums_1ggab71e4b1f4c80b3e8c82dd85570415e44ac1096798c3195819d57ad16de46b4ed7">CY_SMIF_WIDTH_SINGLE</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />address,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />MEMORY_ADDRESS_SIZE,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__enums_1ggab71e4b1f4c80b3e8c82dd85570415e44ac1096798c3195819d57ad16de46b4ed7">CY_SMIF_WIDTH_SINGLE</ref>,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__enums_1ggad776a0db9224477ab865254a32d9e312ae942102fb4b1a03a13ca8950b607520d">CY_SMIF_SLAVE_SELECT_0</ref>,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />0U,<sp /></highlight><highlight class="comment">/*<sp />Not<sp />last<sp />byte,<sp />does<sp />not<sp />disable<sp />nSS<sp />line<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;smifContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Send<sp />programming<sp />data<sp />to<sp />external<sp />memory<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__low__level__functions_1gae84cdf32e45e492e80dea38f9d3a7586">Cy_SMIF_TransmitData</ref>(SMIF,<sp />tst_txBuffer,<sp />TX_SIZE,<sp /><ref kindref="member" refid="group__group__smif__enums_1ggab71e4b1f4c80b3e8c82dd85570415e44ac1096798c3195819d57ad16de46b4ed7">CY_SMIF_WIDTH_SINGLE</ref>,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />NULL,<sp /></highlight><highlight class="comment">/*<sp />Callback<sp />function<sp />is<sp />not<sp />used<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;smifContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wait<sp />while<sp />SMIF<sp />transfers<sp />data<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__smif__low__level__functions_1ga58e965697047847ce906329eb6b5341c">Cy_SMIF_BusyCheck</ref>(SMIF));</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Wait<sp />until<sp />the<sp />memory<sp />is<sp />programed.<sp />Cy_SMIF_MemIsBusy()<sp />of<sp />memslot</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp />*<sp />API<sp />level<sp />could<sp />be<sp />used<sp />instead<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordtype">bool</highlight><highlight class="normal"><sp />memBusy;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">do</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />uint8_t<sp />readReg<sp />=<sp />0U;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Read<sp />the<sp />memory<sp />status<sp />register<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__low__level__functions_1ga5abea630fca93c72faece8b23549cd11">Cy_SMIF_TransmitCommand</ref>(<sp />SMIF,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />0x05U,<sp /></highlight><highlight class="comment">/*<sp />Read<sp />status<sp />register<sp />of<sp />external<sp />memory<sp />*/</highlight><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__enums_1ggab71e4b1f4c80b3e8c82dd85570415e44ac1096798c3195819d57ad16de46b4ed7">CY_SMIF_WIDTH_SINGLE</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CMD_WITHOUT_PARAM,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />CMD_WITHOUT_PARAM,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__enums_1ggab71e4b1f4c80b3e8c82dd85570415e44ac1096798c3195819d57ad16de46b4ed7">CY_SMIF_WIDTH_SINGLE</ref>,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__enums_1ggad776a0db9224477ab865254a32d9e312ae942102fb4b1a03a13ca8950b607520d">CY_SMIF_SLAVE_SELECT_0</ref>,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />0U,<sp /></highlight><highlight class="comment">/*<sp />Not<sp />last<sp />byte,<sp />does<sp />not<sp />disable<sp />nSS<sp />line<sp />*/</highlight><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;smifContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__low__level__functions_1ga1b365e1400ccd6580533a0c92deb48c7">Cy_SMIF_ReceiveData</ref>(SMIF,<sp />&amp;readReg,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />1U,<sp /></highlight><highlight class="comment">/*<sp />Read<sp />1-byte<sp />*/</highlight><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__enums_1ggab71e4b1f4c80b3e8c82dd85570415e44ac1096798c3195819d57ad16de46b4ed7">CY_SMIF_WIDTH_SINGLE</ref>,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />NULL,<sp /></highlight><highlight class="comment">/*<sp />Callback<sp />function<sp />is<sp />not<sp />used<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;smifContext);</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />if<sp />the<sp />SMIF<sp />IP<sp />is<sp />busy<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__smif__low__level__functions_1ga58e965697047847ce906329eb6b5341c">Cy_SMIF_BusyCheck</ref>(SMIF));</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />memBusy<sp />=<sp />((readReg<sp />&amp;<sp />MEM_WIP_MASK)<sp />!=<sp />0U);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />}</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">(memBusy);</highlight></codeline>
</programlisting> For the Read operation, before accessing the read buffer, check that it is ready by calling <ref kindref="member" refid="group__group__smif__low__level__functions_1ga10662c147b39a1b71a2f2221b0e3f59f">Cy_SMIF_GetTxFifoStatus()</ref>.</para><para>Simple example of external flash memory read using low level SMIF API. All steps mentioned in example below are incorporated in <ref kindref="member" refid="group__group__smif__mem__slot__functions_1ga8507571efa28c8187f5e3c795f59fab4">Cy_SMIF_MemCmdRead()</ref> of the <ref kindref="compound" refid="group__group__smif__mem__slot__functions">memory slot level API</ref>. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition warning"&gt;&lt;p class="admonition-title"&gt;warning&lt;/p&gt;&lt;p&gt;&lt;p&gt;Example is simplified, without checks of error conditions. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Refer to external memory datasheet for specific memory commands.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Read<sp />memory<sp />data<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />address[MEMORY_ADDRESS_SIZE]<sp />=<sp />{0U,0U,0U};<sp /></highlight><highlight class="comment">/*<sp />Read<sp />from<sp />3-byte<sp />0<sp />address<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />uint8_t<sp />tst_rxBuffer[RX_SIZE];<sp /></highlight><highlight class="comment">/*<sp />Buffer<sp />to<sp />put<sp />read<sp />date<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__low__level__functions_1ga5abea630fca93c72faece8b23549cd11">Cy_SMIF_TransmitCommand</ref>(SMIF,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />0x03U,<sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />External<sp />memory<sp />Read<sp />command<sp />code<sp />*/</highlight><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__enums_1ggab71e4b1f4c80b3e8c82dd85570415e44ac1096798c3195819d57ad16de46b4ed7">CY_SMIF_WIDTH_SINGLE</ref>,<sp /></highlight><highlight class="comment">/*<sp />Normal<sp />SPI<sp />mode<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />address,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />MEMORY_ADDRESS_SIZE,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__enums_1ggab71e4b1f4c80b3e8c82dd85570415e44ac1096798c3195819d57ad16de46b4ed7">CY_SMIF_WIDTH_SINGLE</ref>,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__enums_1ggad776a0db9224477ab865254a32d9e312ae942102fb4b1a03a13ca8950b607520d">CY_SMIF_SLAVE_SELECT_0</ref>,<sp /></highlight><highlight class="comment">/*<sp />External<sp />memory<sp />connected<sp />to<sp />nSS0<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />0U,<sp /></highlight><highlight class="comment">/*<sp />Not<sp />last<sp />byte,<sp />does<sp />not<sp />disable<sp />nSS<sp />line<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;smifContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__low__level__functions_1ga1b365e1400ccd6580533a0c92deb48c7">Cy_SMIF_ReceiveData</ref>(SMIF,<sp />tst_rxBuffer,<sp />RX_SIZE,<sp /><ref kindref="member" refid="group__group__smif__enums_1ggab71e4b1f4c80b3e8c82dd85570415e44ac1096798c3195819d57ad16de46b4ed7">CY_SMIF_WIDTH_SINGLE</ref>,<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />NULL,<sp /></highlight><highlight class="comment">/*<sp />Callback<sp />function<sp />is<sp />not<sp />used<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;smifContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Check<sp />SMIF<sp />fishes<sp />reading<sp />operation<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="keywordflow">while</highlight><highlight class="normal">(<ref kindref="member" refid="group__group__smif__low__level__functions_1ga9b1a6bbecbb57233ea612d39d53b8f4c">Cy_SMIF_GetTransferStatus</ref>(SMIF,<sp />&amp;smifContext)<sp />==<sp /><ref kindref="member" refid="group__group__smif__enums_1ggaf65a7e26c18fcd3d3469eb083f78bb85af8edf256d08cd59c856ed40dd78b9585">CY_SMIF_RX_BUSY</ref>);</highlight></codeline>
</programlisting> The user should invalidate the cache by calling <ref kindref="member" refid="group__group__smif__low__level__functions_1ga72240c0ce8307c50b65c4fca45c9cd30">Cy_SMIF_CacheInvalidate()</ref> when switching from the MMIO mode to XIP mode.</para>
<para><heading level="1">Configuration Considerations</heading></para>
<para>PDL API has common parameters: base, context, config described in <ref kindref="member" refid="page_getting_started_1page_getting_started_pdl_design">PDL Design</ref> section.</para><para>See the documentation for <ref kindref="member" refid="group__group__smif__low__level__functions_1gaea2684847f04e2e7e2c85cfe7fd37881">Cy_SMIF_Init()</ref> and <ref kindref="member" refid="group__group__smif__mem__slot__functions_1ga6f38cc37ab0e6fcb97d2675d1ae11771">Cy_SMIF_MemInit()</ref> for details on the required configuration structures and other initialization topics.</para><para>The normal (MMIO) mode is used for implementing a generic SPI/DSPI/QSPI/dual QSPI/octal SPI communication interface using the SMIF block. This interface can be used to implement special commands like Program/Erase of flash, memory device configuration, sleep mode entry for memory devices or other special commands specific to the memory device. The transfer width (SPI/DSPI/QSPI/octal SPI) of a transmission is a parameter set for each transmit/receive operation. So these can be changed at run time.</para><para>In a typical memory interface with flash memory, the SMIF is used in the memory mode when reading from the memory and it switches to the normal mode when writing to flash memory. A typical memory device has multiple types of commands.</para><para>The SMIF interface can be used to transmit different types of commands. Each command has different phases: command, dummy cycles, and transmit and receive data which require separate APIs.</para>
<para><bold>SMIF Initialization</bold></para>
<para>Create interrupt function and allocate memory for SMIF context structure <programlisting><codeline><highlight class="normal"><ref kindref="compound" refid="structcy__stc__smif__context__t">cy_stc_smif_context_t</ref><sp />smifContext;</highlight></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="keywordtype">void</highlight><highlight class="normal"><sp />SMIF_Interrupt_User(</highlight><highlight class="keywordtype">void</highlight><highlight class="normal">)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__low__level__functions_1gaedbec6f968745b8f594dd4b32e91ceba">Cy_SMIF_Interrupt</ref>(SMIF,<sp />&amp;smifContext);</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting>SMIF driver initialization for low level API usage (cysmif.h) <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Main<sp />configuration<sp />paramters*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />NUMBER_OF_EXTERNAL_MEM<sp /><sp /><sp /><sp /><sp /><sp />(2U)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />SMIF_PRIORITY<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(1U)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />TIMEOUT_1_S<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(1000U)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#define<sp />DESELECT_DELAY<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(7U)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Pin<sp />initialization<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />SMIF<sp />interrupt<sp />initialization<sp />*/</highlight><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__sysint__t">cy_stc_sysint_t</ref><sp />smifIntConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#if<sp />(CY_CPU_CORTEX_M0P)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.intrSrc<sp />*/</highlight><highlight class="normal"><sp />NvicMux7_IRQn,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.cm0pSrc<sp />*/</highlight><highlight class="normal"><sp />smif_interrupt_IRQn,</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.intrSrc<sp />*/</highlight><highlight class="normal"><sp />smif_interrupt_IRQn,<sp /></highlight><highlight class="comment">/*<sp />SMIF<sp />interrupt<sp />number<sp />(non<sp />M0<sp />core)*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />#endif<sp /><sp /><sp /></highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.intrPriority<sp />*/</highlight><highlight class="normal"><sp />SMIF_PRIORITY</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />(void)<sp /><ref kindref="member" refid="group__group__sysint__functions_1gab2ff6820a898e9af3f780000054eea5d">Cy_SysInt_Init</ref>(&amp;smifIntConfig,<sp />SMIF_Interrupt_User);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />__enable_irq();<sp /></highlight><highlight class="comment">/*<sp />Enable<sp />global<sp />interrupts.<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Enable<sp />SMIF<sp />interrupt<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#if<sp />(__CORTEX_M<sp />==<sp />0)</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />NVIC_EnableIRQ(NvicMux7_IRQn);</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#else</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />NVIC_EnableIRQ(smif_interrupt_IRQn);</highlight></codeline>
<codeline><highlight class="normal" /><highlight class="preprocessor"><sp /><sp /><sp /><sp />#endif</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />SMIF<sp />configuration<sp />parameters<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__smif__config__t">cy_stc_smif_config_t</ref><sp />tst_smifConfig<sp />=<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{<sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.mode<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__smif__enums_1gga2baa7c37d2cedf2e2c837facc753ab5da4fe852fb31547c77b31203ec5c43ca91">CY_SMIF_NORMAL</ref>,<sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Mode<sp />of<sp />operation<sp />*/</highlight><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.deselectDelay<sp /><sp />*/</highlight><highlight class="normal"><sp />DESELECT_DELAY,<sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Minimum<sp />duration<sp />of<sp />SPI<sp />deselection<sp />*/</highlight><highlight class="normal"><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.rxClockSel<sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__smif__enums_1gga6a2149f74b63ec4ebc76b99a9eb633d2a2e6388423a1b56880779651f73b3d2b7">CY_SMIF_SEL_INVERTED_INTERNAL_CLK</ref>,<sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Clock<sp />source<sp />for<sp />the<sp />receiver<sp />clock<sp />*/</highlight><highlight class="normal"><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.blockEvent<sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__smif__enums_1ggaf2f886b17b9d40712b212e704665341ea4ee6427df49e552167b2eb7a70f4afc4">CY_SMIF_BUS_ERROR</ref><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />What<sp />happens<sp />when<sp />there<sp />is<sp />a<sp />read<sp /></highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />to<sp />an<sp />empty<sp />RX<sp />FIFO<sp />or<sp />write<sp />to<sp />a<sp />full<sp />TX<sp />FIFO</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*/</highlight><highlight class="normal"><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />SMIF<sp />initialization<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__low__level__functions_1gaea2684847f04e2e7e2c85cfe7fd37881">Cy_SMIF_Init</ref>(SMIF,<sp />&amp;tst_smifConfig,<sp />TIMEOUT_1_S,<sp />&amp;smifContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__low__level__functions_1ga5428ca682fd56b837a1a3763fc2596b8">Cy_SMIF_Enable</ref>(SMIF,<sp />&amp;smifContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
</programlisting>Additional steps to initialize SMIF driver for memory slot level API usage (cy_smif_memslot.h). <programlisting><codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configuration<sp />parameters<sp />for<sp />memory<sp />S25FL512S*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__smif__mem__device__cfg__t">cy_stc_smif_mem_device_cfg_t</ref><sp />S25FL512S;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configuration<sp />parameters<sp />for<sp />memory<sp />configuration<sp />autodetection*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__smif__mem__device__cfg__t">cy_stc_smif_mem_device_cfg_t</ref><sp />autodetectedMemory;</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__smif__mem__config__t">cy_stc_smif_mem_config_t</ref><sp />memSs0<sp />=<sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.slaveSelect<sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__smif__enums_1ggad776a0db9224477ab865254a32d9e312ae942102fb4b1a03a13ca8950b607520d">CY_SMIF_SLAVE_SELECT_0</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Determines<sp />the<sp />slot<sp />number<sp />where<sp />the<sp />memory<sp />device<sp />is<sp />placed<sp />*/</highlight><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.flags<sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__smif__macros__flags_1ga29c9ff0df16794497a73170841902770">CY_SMIF_FLAG_MEMORY_MAPPED</ref><sp />|<sp /><ref kindref="member" refid="group__group__smif__macros__flags_1gae3932175eef63cefb6740f7b8287067a">CY_SMIF_FLAG_WRITE_ENABLE</ref>,<sp /></highlight><highlight class="comment">/*<sp />Determines<sp />if<sp />the<sp />device<sp />is<sp />memory<sp />mapped.<sp />If<sp />enabled<sp />this<sp />memory<sp />slot<sp />will<sp />be<sp />initialised<sp />in<sp />System<sp />init<sp />*/</highlight><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.dataSelect<sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__smif__enums_1gga6d9ba2ef785b94cf542c573a51a0eb58a7544d58a69a1a2308ebd0cac9099cd24">CY_SMIF_DATA_SEL0</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Data<sp />line<sp />selection<sp />options<sp />for<sp />a<sp />slave<sp />device<sp />*/</highlight><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.baseAddress<sp />*/</highlight><highlight class="normal"><sp />0x18000000UL,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />base<sp />address<sp />the<sp />memory<sp />slave<sp />is<sp />mapped<sp />to<sp />in<sp />the<sp />PSoC<sp />memory<sp />map.<sp />Valid<sp />when<sp />memory<sp />mapped<sp />mode<sp />is<sp />enabled<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.memMappedSize<sp />*/</highlight><highlight class="normal"><sp />0xFFE00000UL,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />The<sp />size<sp />allocated<sp />in<sp />the<sp />PSoC<sp />memory<sp />map,<sp />for<sp />the<sp />memory<sp />slave<sp />device.<sp />The<sp />size<sp />is<sp />allocated<sp />from<sp />the<sp />base<sp />address</highlight></codeline>
<codeline><highlight class="comment"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />*<sp />Valid<sp />when<sp />memory<sp />mapped<sp />mode<sp />is<sp />enabled<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.dualQuadSlots<sp />*/</highlight><highlight class="normal"><sp />0x0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.deviceCfg<sp />*/</highlight><highlight class="normal"><sp />&amp;S25FL512S<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configuration<sp />of<sp />the<sp />device<sp />*/</highlight><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__smif__mem__config__t">cy_stc_smif_mem_config_t</ref><sp />memSs1<sp />=<sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{<sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.slaveSelect<sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__smif__enums_1ggad776a0db9224477ab865254a32d9e312abcce904a4fb5c59af91665287c2cc906">CY_SMIF_SLAVE_SELECT_1</ref>,<sp /></highlight><highlight class="comment">/*<sp />Determines<sp />the<sp />slot<sp />number<sp />where<sp />the<sp />memory<sp />device<sp />is<sp />placed<sp />*/</highlight><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.flags<sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__smif__macros__flags_1ga23e01da45ea8e930e94279967557a1c5">CY_SMIF_FLAG_DETECT_SFDP</ref>,<sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Determines<sp />if<sp />the<sp />device<sp />is<sp />memory<sp />mapped.<sp />If<sp />enabled<sp />this<sp />memory<sp />slot<sp />will<sp />be<sp />initialised<sp />in<sp />System<sp />init<sp />*/</highlight><highlight class="normal"><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.dataSelect<sp />*/</highlight><highlight class="normal"><sp /><ref kindref="member" refid="group__group__smif__enums_1gga6d9ba2ef785b94cf542c573a51a0eb58adb81ab40b00daad8ed642d06a9fd96a4">CY_SMIF_DATA_SEL2</ref>,<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Data<sp />line<sp />selection<sp />options<sp />for<sp />a<sp />slave<sp />device<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.baseAddress<sp />*/</highlight><highlight class="normal"><sp />0x0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.memMappedSize<sp />*/</highlight><highlight class="normal"><sp />0x0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.dualQuadSlots<sp />*/</highlight><highlight class="normal"><sp />0x0UL,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.deviceCfg<sp />*/</highlight><highlight class="normal"><sp />&amp;autodetectedMemory<sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Configuration<sp />of<sp />the<sp />device<sp />*/</highlight><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__smif__mem__config__t">cy_stc_smif_mem_config_t</ref>*<sp />smifMemConfigs[NUMBER_OF_EXTERNAL_MEM]<sp />=<sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;memSs0,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />&amp;memSs1,</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="compound" refid="structcy__stc__smif__block__config__t">cy_stc_smif_block_config_t</ref><sp />smifBlockConfig<sp />=</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.memCount<sp />*/</highlight><highlight class="normal"><sp />NUMBER_OF_EXTERNAL_MEM,<sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Number<sp />of<sp />SMIF<sp />memories<sp />defined<sp /><sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.memConfig<sp />*/</highlight><highlight class="normal"><sp />smifMemConfigs,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Pointer<sp />to<sp />the<sp />array<sp />of<sp />memory<sp />configuration<sp />structures<sp />of<sp />size<sp />memCount<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.majorVersion<sp />*/</highlight><highlight class="normal"><sp />1U,<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Version<sp />of<sp />the<sp />SMIF<sp />driver<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />.minorVersion<sp />*/</highlight><highlight class="normal"><sp />0U<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Version<sp />of<sp />the<sp />SMIF<sp />Driver<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />};</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Memslot<sp />level<sp />initialization<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__mem__slot__functions_1ga6f38cc37ab0e6fcb97d2675d1ae11771">Cy_SMIF_MemInit</ref>(SMIF,<sp />&amp;smifBlockConfig,<sp />&amp;smifContext);</highlight></codeline>
</programlisting><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Example does not include initialization of all needed configuration structures (&lt;a href="structcy__stc__smif__mem__device__cfg__t.html#"&gt;cy_stc_smif_mem_device_cfg_t&lt;/a&gt;, &lt;a href="structcy__stc__smif__mem__cmd__t.html#"&gt;cy_stc_smif_mem_cmd_t&lt;/a&gt;). SMIF/QSPI Configuration tool generates all configuration structures needed for memslot level API usage.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><bold>SMIF XIP Initialization</bold></para>
<para>The eXecute In Place (XIP) is a mode of operation where read or write commands to the memory device are directed through the SMIF without any use of API function calls. In this mode the SMIF block maps the AHB bus-accesses to external memory device addresses to make it behave similar to internal memory. This allows the CPU to execute code directly from external memory. This mode is not limited to code and is suitable also for data read and write accesses. The memory regions available for XIP addresses allocation are defined in a linker script file (.ld). <programlisting><codeline><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />SMIF<sp />IP<sp />initialization<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__low__level__functions_1gaea2684847f04e2e7e2c85cfe7fd37881">Cy_SMIF_Init</ref>(SMIF,<sp />&amp;tst_smifConfig,<sp />TIMEOUT_1_S,<sp />&amp;smifContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__low__level__functions_1ga1df033f6664a2b41cf044f2c4ec60817">Cy_SMIF_SetDataSelect</ref>(SMIF,<sp /><ref kindref="member" refid="group__group__smif__enums_1ggad776a0db9224477ab865254a32d9e312ae942102fb4b1a03a13ca8950b607520d">CY_SMIF_SLAVE_SELECT_0</ref>,<sp /><ref kindref="member" refid="group__group__smif__enums_1gga6d9ba2ef785b94cf542c573a51a0eb58a7544d58a69a1a2308ebd0cac9099cd24">CY_SMIF_DATA_SEL0</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__mem__slot__functions_1ga6f38cc37ab0e6fcb97d2675d1ae11771">Cy_SMIF_MemInit</ref>(SMIF,<sp />&amp;smifBlockConfig,<sp />&amp;smifContext);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight><highlight class="comment">/*<sp />Set<sp />XIP<sp />mode<sp />*/</highlight><highlight class="normal" /></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__low__level__functions_1ga957f49ed7cf091e9b9d736ee589f2583">Cy_SMIF_SetMode</ref>(SMIF,<sp /><ref kindref="member" refid="group__group__smif__enums_1gga2baa7c37d2cedf2e2c837facc753ab5da562131834e2b77b141db45354e8584ec">CY_SMIF_MEMORY</ref>);</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /></highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp /><ref kindref="member" refid="group__group__smif__low__level__functions_1ga5428ca682fd56b837a1a3763fc2596b8">Cy_SMIF_Enable</ref>(SMIF,<sp />(<ref kindref="compound" refid="structcy__stc__smif__context__t">cy_stc_smif_context_t</ref><sp />*)&amp;smifContext);</highlight></codeline>
</programlisting><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Example of input parameters initialization is in &lt;a href="#group__group__smif_1group_smif_init"&gt;SMIF Initialization&lt;/a&gt; section. &lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition warning"&gt;&lt;p class="admonition-title"&gt;warning&lt;/p&gt;&lt;p&gt;&lt;p&gt;Functions that called from external memory should be declared with long call attribute.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><bold>Rules for PSoC6 QSPI/SMIF Block Usage</bold></para>
<para><orderedlist>
<listitem><para>All operations must use one or more dummy cycles between the PSoC 6 Command and Address phase (when the PSoC 6 MCU drives the data pins) and the device's Response phase (when the device drives the same data pins). Bus contention may occur if no (zero) dummy cycles are used.</para></listitem><listitem><para>Any transfer that does not allow dummy cycles (such as Register Status Reads) must use the single-bit transfer mode. In single-bit mode, the PSoC 6 drives the Command on the Data0 line and the device responds on the Data1 line, so bus contention cannot occur.</para></listitem></orderedlist>
</para>


<para><heading level="1">More Information</heading></para>
<para>More information regarding the Serial Memory Interface can be found in the component datasheet and the Technical Reference Manual (TRM). More information regarding the SMIF Configuration Tool are in SMIF Configuration Tool User Guide located in &lt;PDL_DIR&gt;/tools/&lt;OS_DIR&gt;/SMIFConfigurationTool/ folder</para>

<para><heading level="1">MISRA-C Compliance]</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;11.4 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;A &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The cast is be performed between a pointer to the object type and a different pointer to the object type. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The cast from the pointer to void to the pointer to an unsigned integer does not have any unintended effect, as it is a consequence of the definition of a structure based on hardware registers.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;11.5 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Not performed, the cast that removes any const or volatile qualification from the type addressed by a pointer. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The removal of the volatile qualification inside the function has no side effects.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes&lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.50.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Minor documentation updates.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation improvement.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.50 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added a new function: &lt;a href="group__group__smif__mem__slot__functions.html#group__group__smif__mem__slot__functions_1ga2ecd32504ba15c504203a6ac3daee4c4"&gt;Cy_SMIF_MemLocateHybridRegion&lt;/a&gt;.&lt;br /&gt; Added a new structure &lt;a href="structcy__stc__smif__hybrid__region__info__t.html#"&gt;cy_stc_smif_hybrid_region_info_t&lt;/a&gt;.&lt;br /&gt; Updated the &lt;a href="group__group__smif__mem__slot__functions.html#group__group__smif__mem__slot__functions_1ga0366724555c54f148c6bec37f084897c"&gt;Cy_SMIF_MemEraseSector&lt;/a&gt; and &lt;a href="group__group__smif__mem__slot__functions.html#group__group__smif__mem__slot__functions_1ga885d4bee96580b23b2176917b0cc0ea2"&gt;Cy_SMIF_MemCmdSectorErase&lt;/a&gt; functions.&lt;br /&gt; Updated the &lt;a href="group__group__smif__mem__slot__functions.html#group__group__smif__mem__slot__functions_1ga7f74353f55fbe56cdc8c93285bbb51d6"&gt;Cy_SMIF_MemSfdpDetect&lt;/a&gt; function. &lt;br /&gt; Updated the &lt;a href="structcy__stc__smif__mem__device__cfg__t.html#"&gt;cy_stc_smif_mem_device_cfg_t&lt;/a&gt; structure. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Support for memories with hybrid regions.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;1.40.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The &lt;a href="group__group__smif__mem__slot__functions.html#group__group__smif__mem__slot__functions_1ga6f38cc37ab0e6fcb97d2675d1ae11771"&gt;Cy_SMIF_MemInit&lt;/a&gt; is changed.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Corrected a false assertion during initialization in SFDP mode.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Minor documentation updates.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="5"&gt;&lt;p&gt;1.40 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The following functions are renamed:&lt;br /&gt; Cy_SMIF_GetTxfrStatus into Cy_SMIF_GetTransferStatus;&lt;br /&gt; Cy_SMIF_Memslot_Init into Cy_SMIF_MemInit;&lt;br /&gt; Cy_SMIF_Memslot_DeInit into Cy_SMIF_MemDeInit;&lt;br /&gt; Cy_SMIF_Memslot_CmdWriteEnable into Cy_SMIF_MemCmdWriteEnable;&lt;br /&gt; Cy_SMIF_Memslot_CmdWriteDisable into Cy_SMIF_MemCmdWriteDisable;&lt;br /&gt; Cy_SMIF_Memslot_IsBusy into Cy_SMIF_MemIsBusy;&lt;br /&gt; Cy_SMIF_Memslot_QuadEnable into Cy_SMIF_MemQuadEnable;&lt;br /&gt; Cy_SMIF_Memslot_CmdReadSts into Cy_SMIF_MemCmdReadStatus;&lt;br /&gt; Cy_SMIF_Memslot_CmdWriteSts into Cy_SMIF_MemCmdWriteStatus;&lt;br /&gt; Cy_SMIF_Memslot_CmdChipErase into Cy_SMIF_MemCmdChipErase;&lt;br /&gt; Cy_SMIF_Memslot_CmdSectorErase into Cy_SMIF_MemCmdSectorErase;&lt;br /&gt; Cy_SMIF_Memslot_SfdpDetect into Cy_SMIF_MemSfdpDetect;&lt;br /&gt; Cy_SMIF_Memslot_CmdProgram into Cy_SMIF_MemCmdProgram;&lt;br /&gt; Cy_SMIF_Memslot_CmdRead into Cy_SMIF_MemCmdRead.&lt;br /&gt; The following ENUMa are renamed:&lt;br /&gt; CY_SMIF_SEND_CMPLT into CY_SMIF_SEND_COMPLETE;&lt;br /&gt; CY_SMIF_REC_CMPLT into CY_SMIF_RX_COMPLETE;&lt;br /&gt; CY_SMIF_REC_BUSY into CY_SMIF_RX_BUSY;&lt;br /&gt; CY_SMIF_SEL_INV_INTERNAL_CLK into CY_SMIF_SEL_INVERTED_INTERNAL_CLK;&lt;br /&gt; CY_SMIF_SEL_INV_FEEDBACK_CLK into CY_SMIF_SEL_INVERTED_FEEDBACK_CLK;&lt;br /&gt; cy_en_smif_cache_en_t into cy_en_smif_cache_t.&lt;br /&gt; The following MACROs are renamed:&lt;br /&gt; CY_SMIF_FLAG_WR_EN into CY_SMIF_FLAG_WRITE_ENABLE;&lt;br /&gt; CY_SMIF_FLAG_CRYPTO_EN into CY_SMIF_FLAG_CRYPTO_ENABLE;&lt;br /&gt; CY_SMIF_SFDP_SING_BYTE_00 into CY_SMIF_SFDP_SIGNATURE_BYTE_00;&lt;br /&gt; CY_SMIF_SFDP_SING_BYTE_01 into CY_SMIF_SFDP_SIGNATURE_BYTE_01;&lt;br /&gt; CY_SMIF_SFDP_SING_BYTE_02 into CY_SMIF_SFDP_SIGNATURE_BYTE_02;&lt;br /&gt; CY_SMIF_SFDP_SING_BYTE_03 into CY_SMIF_SFDP_SIGNATURE_BYTE_03;&lt;br /&gt; CY_SMIF_WR_STS_REG1_CMD into CY_SMIF_WRITE_STATUS_REG1_CMD;&lt;br /&gt; CY_SMIF_WR_DISABLE_CMD into CY_SMIF_WRITE_DISABLE_CMD;&lt;br /&gt; CY_SMIF_RD_STS_REG1_CMD into CY_SMIF_READ_STATUS_REG1_CMD;&lt;br /&gt; CY_SMIF_WR_ENABLE_CMD into CY_SMIF_WRITE_ENABLE_CMD;&lt;br /&gt; CY_SMIF_RD_STS_REG2_T1_CMD into CY_SMIF_READ_STATUS_REG2_T1_CMD;&lt;br /&gt; CY_SMIF_WR_STS_REG2_CMD into CY_SMIF_WRITE_STATUS_REG2_CMD;&lt;br /&gt; CY_SMIF_RD_STS_REG2_T2_CMD into CY_SMIF_READ_STATUS_REG2_T2_CMD;&lt;br /&gt; CY_SMIF_QE_BIT_STS_REG2_T1 into CY_SMIF_QE_BIT_STATUS_REG2_T1;&lt;br /&gt; CY_SMIF_STS_REG_BUSY_MASK into CY_SMIF_STATUS_REG_BUSY_MASK.&lt;br /&gt;  &lt;/p&gt;&lt;/td&gt;&lt;td rowspan="2"&gt;&lt;p&gt;Documentation improvement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the description of the &lt;a href="group__group__smif__mem__slot__functions.html#group__group__smif__mem__slot__functions_1ga6f38cc37ab0e6fcb97d2675d1ae11771"&gt;Cy_SMIF_MemInit()&lt;/a&gt; function. Updated the &lt;a href="group__group__smif__low__level__functions.html#group__group__smif__low__level__functions_1ga91a32005b94591adb8fd7daa1068ddbc"&gt;Cy_SMIF_Encrypt()&lt;/a&gt; function usage example.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;The type of arguments that are not modified by the functions are set to const.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Usability improvement.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;The &lt;a href="group__group__smif__mem__slot__functions.html#group__group__smif__mem__slot__functions_1ga7f74353f55fbe56cdc8c93285bbb51d6"&gt;Cy_SMIF_MemSfdpDetect()&lt;/a&gt; function is updated to support new commands for 4 bytes addressing.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Memory devices with new 4 byte addressing commands support.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added the blocking functions which take care of the busy-status check of the memory:&lt;ul&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__smif__mem__slot__functions.html#group__group__smif__mem__slot__functions_1ga7538e07a8ab513b8ef223a93528cb4da"&gt;Cy_SMIF_MemIsReady&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__smif__mem__slot__functions.html#group__group__smif__mem__slot__functions_1ga2967ce386fb4510033571fa67dc69ef7"&gt;Cy_SMIF_MemIsQuadEnabled&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__smif__mem__slot__functions.html#group__group__smif__mem__slot__functions_1ga1be9fc6a3d0579ed6dcbf4b0f843c98b"&gt;Cy_SMIF_MemEnableQuadMode&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__smif__mem__slot__functions.html#group__group__smif__mem__slot__functions_1ga3855957e67febf53caa00216461e87c2"&gt;Cy_SMIF_MemRead&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__smif__mem__slot__functions.html#group__group__smif__mem__slot__functions_1gad1ca5ea17379f15e77bd0a7daea50598"&gt;Cy_SMIF_MemWrite&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__smif__mem__slot__functions.html#group__group__smif__mem__slot__functions_1ga0366724555c54f148c6bec37f084897c"&gt;Cy_SMIF_MemEraseSector&lt;/a&gt;&lt;/p&gt;&lt;/li&gt;&lt;li&gt;&lt;p&gt;&lt;a href="group__group__smif__mem__slot__functions.html#group__group__smif__mem__slot__functions_1ga7525385db143137bd0e16a82e248243d"&gt;Cy_SMIF_MemEraseChip&lt;/a&gt;  &lt;/p&gt;&lt;/li&gt;&lt;/ul&gt;&lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added new high-level blocking functions.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="5"&gt;&lt;p&gt;1.30 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The CY_SMIF_CMD_FIFO_WR_RX_COUNT_Msk value is changed to 0x0000FFFFUL. &lt;/p&gt;&lt;/td&gt;&lt;td rowspan="4"&gt;&lt;p&gt;Driver maintenance.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added the check of the size parameter in the &lt;a href="group__group__smif__low__level__functions.html#group__group__smif__low__level__functions_1gae84cdf32e45e492e80dea38f9d3a7586"&gt;Cy_SMIF_TransmitData()&lt;/a&gt; function.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added conditional check for presence of the SMIF hardware IP.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Fixed the wrong erase command in the SFDP protocol for devices with Erase Type 3.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the General Description section with minor changes. Updated the ordering of the parameters descriptions for some functions. Added the text saying that the &lt;a href="group__group__smif__mem__slot__functions.html#group__group__smif__mem__slot__functions_1ga6f38cc37ab0e6fcb97d2675d1ae11771"&gt;Cy_SMIF_MemInit()&lt;/a&gt; function is applicable to use the external memory as memory-mapped to PSoC (XIP mode). Added the snippet for the &lt;a href="group__group__smif__low__level__functions.html#group__group__smif__low__level__functions_1ga91a32005b94591adb8fd7daa1068ddbc"&gt;Cy_SMIF_Encrypt()&lt;/a&gt; function to show how to use this function. Added below the picture in the Low-Level Functions section the sequence of PDL functions required in a Read or Write transaction. Added the text below the picture about the address. Updated DUMMY COUNT in this picture. Added checking of the size parameter in the &lt;a href="group__group__smif__low__level__functions.html#group__group__smif__low__level__functions_1gae84cdf32e45e492e80dea38f9d3a7586"&gt;Cy_SMIF_TransmitData()&lt;/a&gt; function.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation improvement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.20.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added upper limit to size parameter in several functions. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation improvement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="3"&gt;&lt;p&gt;1.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Flattened the organization of the driver source code into the single source directory and the single include directory.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Driver library directory-structure simplification.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added a new return status and transfer width option for the case when the memory command is not supported. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improved the memory command structure usability.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added register access layer. Use register access macros instead of direct register access using dereferenced pointers. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Makes register access device-independent, so that the PDL does not need to be recompiled for each supported part number.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;1.11 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Fixed internal function that writes to the SMIF FIFO &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The write function stuck in the loop when write speed in external memory is significantly lower than PSoC CPU core speed and write transfer is not finished during the single function call.   &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added optional mode part to the program command flow &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Extend usability of program command  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added Low Power Callback section &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation update and clarification  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Fix write to external memory from CM0+ core. Add checks of API input parameters. Minor documentation updates &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>